(* This file is auto-generated using prebuild from files in src-json *)
(* Do not edit manually! *)

open Globals

type define_parameter =
	| HasParam of string
	| Platforms of platform list
	| Link of string
	| Deprecated of string
type strict_defined =
	| AbsolutePath
	| AdvancedTelemetry
	| AnalyzerOptimize
	| AnalyzerTimes
	| AnnotateSource
	| CheckXmlProxy
	| CoreApi
	| CoreApiSerialize
	| Cppia
	| CsVer
	| NoCppiaAst
	| Dce
	| DceDebug
	| Debug
	| DisableUnicodeStrings
	| Display
	| DisplayStdin
	| DllExport
	| DllImport
	| DocGen
	| Dump
	| DumpPath
	| DumpDependencies
	| DumpIgnoreVarIds
	| DynamicInterfaceClosures
	| EraseGenerics
	| EvalCallStackDepth
	| EvalDebugger
	| EvalPrintDepth
	| EvalPrettyPrint
	| EvalStack
	| EvalTimes
	| FilterTimes
	| FastCast
	| Fdb
	| FileExtension
	| FlashStrict
	| FlashUseStage
	| ForceLibCheck
	| ForceNativeProperty
	| GencommonDebug
	| Haxe3Compat
	| HaxeBoot
	| HaxeVer
	| Haxe
	| HaxeNext
	| Hlc
	| HlVer
	| HxcppApiLevel
	| HxcppGcGenerational
	| HxcppDebugger
	| HxcppSmartStings
	| IncludePrefix
	| Interp
	| JarLegacyLoader
	| JavaVer
	| JsClassic
	| JsEs
	| JsEnumsAsArrays
	| JsGlobal
	| JsUnflatten
	| JsSourceMap
	| SourceMap
	| Jvm
	| JvmCompressionLevel
	| JvmDynamicLevel
	| KeepOldOutput
	| LoopUnrollMaxCost
	| LuaJit
	| LuaVanilla
	| LuaVer
	| Macro
	| MacroTimes
	| NetVer
	| NetcoreVer
	| NetTarget
	| NekoSource
	| NekoNoHaxelibPaths
	| NekoV1
	| NetworkSandbox
	| NoCompilation
	| NoDebug
	| NoDeprecationWarnings
	| NoFlashOverride
	| NoOpt
	| NoInline
	| KeepInlinePositions
	| NoRoot
	| NoMacroCache
	| NoSwfCompress
	| NoTraces
	| Objc
	| OldErrorFormat
	| PhpPrefix
	| PhpLib
	| PhpFront
	| PythonVersion
	| RealPosition
	| ReplaceFiles
	| RetainUntypedMeta
	| Scriptable
	| ShallowExpose
	| SourceHeader
	| SourceMapContent
	| Static
	| StdEncodingUtf8
	| Swc
	| SwfCompressLevel
	| SwfDebugPassword
	| SwfDirectBlit
	| SwfGpu
	| SwfHeader
	| SwfMetadata
	| SwfPreloaderFrame
	| SwfProtected
	| SwfScriptTimeout
	| SwfUseDoAbc
	| Sys
	| Unsafe
	| UseNekoc
	| Utf16
	| Vcproj
	| WarnVarShadowing
	| NoTre
	| MessageReporting
	| MessageNoColor
	| MessageLogFile
	| MessageLogFormat
	| Last
	| Custom of string

let infos = function
	| AbsolutePath -> "absolute_path",("Print absolute file path in trace output.",[])
	| AdvancedTelemetry -> "advanced_telemetry",("Allow the SWF to be measured with Monocle tool.",[Platforms [Flash]; Deprecated("The flash target will be removed for Haxe 5")])
	| AnalyzerOptimize -> "analyzer_optimize",("Perform advanced optimizations.",[])
	| AnalyzerTimes -> "analyzer_times",("Record detailed timers for the analyzer",[HasParam "level: 0 | 1 | 2"])
	| AnnotateSource -> "annotate_source",("Add additional comments to generated source code.",[Platforms [Cpp]])
	| CheckXmlProxy -> "check_xml_proxy",("Check the used fields of the XML proxy.",[])
	| CoreApi -> "core_api",("Defined in the core API context.",[])
	| CoreApiSerialize -> "core_api_serialize",("Mark some generated core API classes with the `Serializable` attribute on C#.",[Platforms [Cs]])
	| Cppia -> "cppia",("Generate cpp instruction assembly.",[])
	| CsVer -> "cs_ver",("The C# version to target.",[Platforms [Cs]; HasParam "version"])
	| NoCppiaAst -> "nocppiaast",("Use legacy cppia generation.",[])
	| Dce -> "dce",("Set the dead code elimination mode. (default: std)",[HasParam "mode: std | full | no"; Link "https://haxe.org/manual/cr-dce.html"])
	| DceDebug -> "dce_debug",("Show DCE log.",[Link "https://haxe.org/manual/cr-dce.html"])
	| Debug -> "debug",("Activated when compiling with -debug.",[])
	| DisableUnicodeStrings -> "disable_unicode_strings",("Disable Unicode support in `String` type.",[Platforms [Cpp]])
	| Display -> "display",("Activated during completion.",[Link "https://haxe.org/manual/cr-completion.html"])
	| DisplayStdin -> "display_stdin",("Read the contents of a file specified in `--display` from standard input.",[])
	| DllExport -> "dll_export",("GenCPP experimental linking.",[Platforms [Cpp]])
	| DllImport -> "dll_import",("Handle Haxe-generated .NET DLL imports.",[Platforms [Cs]])
	| DocGen -> "doc_gen",("Do not perform any removal/change in order to correctly generate documentation.",[])
	| Dump -> "dump",("Dump typed AST in dump subdirectory using specified mode or non-prettified default.",[HasParam "mode: pretty | record | position | legacy"])
	| DumpPath -> "dump_path",("Path to generate dumps to (default: \"dump\").",[HasParam "path"])
	| DumpDependencies -> "dump_dependencies",("Dump the classes dependencies in a dump subdirectory.",[])
	| DumpIgnoreVarIds -> "dump_ignore_var_ids",("Remove variable IDs from non-pretty dumps (helps with diff).",[])
	| DynamicInterfaceClosures -> "dynamic_interface_closures",("Use slow path for interface closures to save space.",[Platforms [Cpp]])
	| EraseGenerics -> "erase_generics",("Erase generic classes on C#.",[Platforms [Cs]])
	| EvalCallStackDepth -> "eval_call_stack_depth",("Set maximum call stack depth for eval. (default: 1000)",[Platforms [Eval]; HasParam "depth"])
	| EvalDebugger -> "eval_debugger",("Support debugger in macro/interp mode. Allows `host:port` value to open a socket. Implies eval-stack.",[Platforms [Eval]])
	| EvalPrintDepth -> "eval_print_depth",("Set maximum print depth (before replacing with '<...>') for eval. (default: 5)",[Platforms [Eval]; HasParam "depth"])
	| EvalPrettyPrint -> "eval_pretty_print",("Enable indented output for eval printing.",[Platforms [Eval]])
	| EvalStack -> "eval_stack",("Record stack information in macro/interp mode.",[Platforms [Eval]])
	| EvalTimes -> "eval_times",("Record per-method execution times in macro/interp mode. Implies eval-stack.",[Platforms [Eval]])
	| FilterTimes -> "filter_times",("Record per-filter execution times upon --times.",[])
	| FastCast -> "fast_cast",("Enables an experimental casts cleanup on C# and Java.",[Platforms [Cs;Java]])
	| Fdb -> "fdb",("Enable full flash debug infos for FDB interactive debugging.",[Platforms [Flash]; Deprecated("The flash target will be removed for Haxe 5")])
	| FileExtension -> "file_extension",("Output filename extension for cpp source code.",[Platforms [Cpp]])
	| FlashStrict -> "flash_strict",("More strict typing for flash target.",[Platforms [Flash]; Deprecated("The flash target will be removed for Haxe 5")])
	| FlashUseStage -> "flash_use_stage",("Keep the SWF library initial stage.",[Platforms [Flash]; Deprecated("The flash target will be removed for Haxe 5")])
	| ForceLibCheck -> "force_lib_check",("Force the compiler to check `--net-lib` and `--java-lib` added classes (internal).",[Platforms [Cs;Java]])
	| ForceNativeProperty -> "force_native_property",("Tag all properties with `:nativeProperty` metadata for 3.1 compatibility.",[Platforms [Cpp]])
	| GencommonDebug -> "gencommon_debug",("GenCommon internal.",[Platforms [Cs;Java]])
	| Haxe3Compat -> "haxe3compat",("Gives warnings about transition from Haxe 3.x to Haxe 4.0.",[Deprecated("This flag is no longer supported in Haxe 5")])
	| HaxeBoot -> "haxe_boot",("Give the name 'haxe' to the flash boot class instead of a generated name.",[Platforms [Flash]; Deprecated("The flash target will be removed for Haxe 5")])
	| HaxeVer -> "haxe_ver",("The current Haxe version value as decimal number. E.g. 3.407 for 3.4.7.",[])
	| Haxe -> "haxe",("The current Haxe version value in SemVer format.",[])
	| HaxeNext -> "haxe_next",("Enable experimental features that are meant to be released on next Haxe version.",[])
	| Hlc -> "hlc",("Defined by compiler when using hl/c target.",[Platforms [Hl]])
	| HlVer -> "hl_ver",("The HashLink version to target. (default: 1.10.0)",[Platforms [Hl]; HasParam "version"])
	| HxcppApiLevel -> "hxcpp_api_level",("Provided to allow compatibility between hxcpp versions.",[Platforms [Cpp]])
	| HxcppGcGenerational -> "HXCPP_GC_GENERATIONAL",("Experimental Garbage Collector.",[Platforms [Cpp]])
	| HxcppDebugger -> "HXCPP_DEBUGGER",("Include additional information for hxcpp-debugger.",[Platforms [Cpp]])
	| HxcppSmartStings -> "hxcpp_smart_strings",("Use wide strings in hxcpp. (Turned on by default unless `-D disable-unicode-strings` is specified.)",[Platforms [Cpp]])
	| IncludePrefix -> "include_prefix",("Prepend path to generated include files.",[Platforms [Cpp]])
	| Interp -> "interp",("The code is compiled to be run with `--interp`.",[])
	| JarLegacyLoader -> "jar_legacy_loader",("Use the legacy loader to load .jar files on the JVM target.",[Platforms [Java]; Deprecated("The legacy JAR loader will be removed in Haxe 5")])
	| JavaVer -> "java_ver",("Sets the Java version to be targeted.",[Platforms [Java]; HasParam "version: 5-7"])
	| JsClassic -> "js_classic",("Don't use a function wrapper and strict mode in JS output.",[Platforms [Js]])
	| JsEs -> "js_es",("Generate JS compliant with given ES standard version. (default: 5)",[Platforms [Js]; HasParam "version: 3 | 5 | 6"; Link "https://haxe.org/manual/target-javascript-es6.html"])
	| JsEnumsAsArrays -> "js_enums_as_arrays",("Generate enum representation as array instead of as object.",[Platforms [Js]])
	| JsGlobal -> "js_global",("Customizes the global object name.",[Platforms [Js]])
	| JsUnflatten -> "js_unflatten",("Generate nested objects for packages and types.",[Platforms [Js]])
	| JsSourceMap -> "js_source_map",("Generate JavaScript source map even in non-debug mode. Deprecated in favor of `-D source-map`.",[Platforms [Js]])
	| SourceMap -> "source_map",("Generate source map for compiled files.",[Platforms [Php;Js]])
	| Jvm -> "jvm",("Generate jvm directly.",[Platforms [Java]])
	| JvmCompressionLevel -> "jvm.compression_level",("Set the compression level of the generated file between 0 (no compression) and 9 (highest compression). Default: 6",[Platforms [Java]])
	| JvmDynamicLevel -> "jvm.dynamic_level",("Controls the amount of dynamic support code being generated. 0 = none, 1 = field read/write optimization (default), 2 = compile-time method closures",[Platforms [Java]])
	| KeepOldOutput -> "keep_old_output",("Keep old source files in the output directory.",[Platforms [Cs;Java]])
	| LoopUnrollMaxCost -> "loop_unroll_max_cost",("Maximum cost (number of expressions * iterations) before loop unrolling is canceled. (default: 250)",[HasParam "cost"])
	| LuaJit -> "lua_jit",("Enable the jit compiler for lua (version 5.2 only).",[Platforms [Lua]])
	| LuaVanilla -> "lua_vanilla",("Generate code lacking compiled extern lib support (e.g. utf8).",[Platforms [Lua]])
	| LuaVer -> "lua_ver",("The lua version to target.",[Platforms [Lua]; HasParam "version"])
	| Macro -> "macro",("Defined when code is compiled in the macro context.",[Link "https://haxe.org/manual/macro.html"])
	| MacroTimes -> "macro_times",("Display per-macro timing when used with `--times`.",[])
	| NetVer -> "net_ver",("Sets the .NET version to be targeted.",[Platforms [Cs]; HasParam "version: 20-50"])
	| NetcoreVer -> "netcore_ver",("Sets the .NET core version to be targeted",[Platforms [Cs]; HasParam "version: x.x.x"])
	| NetTarget -> "net_target",("Sets the .NET target. `netcore` (.NET core), `xbox`, `micro` (Micro Framework), `compact` (Compact Framework) are some valid values. (default: `net`)",[Platforms [Cs]; HasParam "name"])
	| NekoSource -> "neko_source",("Output neko source instead of bytecode.",[Platforms [Neko]])
	| NekoNoHaxelibPaths -> "neko_no_haxelib_paths",("Disable hard-coded Haxelib ndll paths.",[Platforms [Neko]])
	| NekoV1 -> "neko_v1",("Keep Neko 1.x compatibility.",[Platforms [Neko]])
	| NetworkSandbox -> "network_sandbox",("Use local network sandbox instead of local file access one.",[Platforms [Flash]; Deprecated("The flash target will be removed for Haxe 5")])
	| NoCompilation -> "no_compilation",("Disable final compilation.",[Platforms [Cs;Java;Cpp;Hl]])
	| NoDebug -> "no_debug",("Remove all debug macros from cpp output.",[])
	| NoDeprecationWarnings -> "no_deprecation_warnings",("Do not warn if fields annotated with `@:deprecated` are used.",[])
	| NoFlashOverride -> "no_flash_override",("Change overrides on some basic classes into HX suffixed methods",[Platforms [Flash]; Deprecated("The flash target will be removed for Haxe 5")])
	| NoOpt -> "no_opt",("Disable optimizations.",[])
	| NoInline -> "no_inline",("Disable inlining.",[Link "https://haxe.org/manual/class-field-inline.html"])
	| KeepInlinePositions -> "keep_inline_positions",("Don't substitute positions of inlined expressions with the position of the place of inlining.",[Link "https://haxe.org/manual/class-field-inline.html"])
	| NoRoot -> "no_root",("Generate top-level types into the `haxe.root` namespace.",[Platforms [Cs]])
	| NoMacroCache -> "no_macro_cache",("Disable macro context caching.",[])
	| NoSwfCompress -> "no_swf_compress",("Disable SWF output compression.",[Platforms [Flash]; Deprecated("The flash target will be removed for Haxe 5")])
	| NoTraces -> "no_traces",("Disable all trace calls.",[])
	| Objc -> "objc",("Sets the hxcpp output to Objective-C++ classes. Must be defined for interop.",[Platforms [Cpp]])
	| OldErrorFormat -> "old_error_format",("Use Haxe 3.x zero-based column error messages instead of new one-based format.",[])
	| PhpPrefix -> "php_prefix",("Root namespace for generated php classes. E.g. if compiled with`-D php-prefix=some.sub`, then all classes will be generated in `\\some\\sub` namespace.",[Platforms [Php]; HasParam "dot-separated namespace"])
	| PhpLib -> "php_lib",("Select the name for the php lib folder.",[Platforms [Php]; HasParam "folder name"])
	| PhpFront -> "php_front",("Select the name for the php front file. (default: `index.php`)",[Platforms [Php]; HasParam "filename"])
	| PythonVersion -> "python_version",("The python version to target. (default: 3.3)",[Platforms [Python]; HasParam "version"])
	| RealPosition -> "real_position",("Disables Haxe source mapping when targetting C#, removes position comments in Java and Php output.",[Platforms [Cs;Java;Php]])
	| ReplaceFiles -> "replace_files",("GenCommon internal.",[Platforms [Cs;Java]])
	| RetainUntypedMeta -> "retain_untyped_meta",("Prevents arbitrary expression metadata from being discarded upon typing.",[])
	| Scriptable -> "scriptable",("GenCPP internal.",[Platforms [Cpp]])
	| ShallowExpose -> "shallow_expose",("Expose types to surrounding scope of Haxe generated closure without writing to window object.",[Platforms [Js]])
	| SourceHeader -> "source_header",("Print value as comment on top of generated files, use '' value to disable.",[])
	| SourceMapContent -> "source_map_content",("Include the Haxe sources as part of the JS source map.",[Platforms [Js]])
	| Static -> "static",("Defined if the current target is static.",[])
	| StdEncodingUtf8 -> "std_encoding_utf8",("Force utf8 encoding for stdin, stdout and stderr",[Platforms [Java;Cs;Python]])
	| Swc -> "swc",("Output a SWC instead of a SWF.",[Platforms [Flash]; Deprecated("The flash target will be removed for Haxe 5")])
	| SwfCompressLevel -> "swf_compress_level",("Set the amount of compression for the SWF output.",[Platforms [Flash]; HasParam "level: 1-9"; Deprecated("The flash target will be removed for Haxe 5")])
	| SwfDebugPassword -> "swf_debug_password",("Set a password for debugging.",[Platforms [Flash]; HasParam "password"; Deprecated("The flash target will be removed for Haxe 5")])
	| SwfDirectBlit -> "swf_direct_blit",("Use hardware acceleration to blit graphics.",[Platforms [Flash]; Deprecated("The flash target will be removed for Haxe 5")])
	| SwfGpu -> "swf_gpu",("Use GPU compositing features when drawing graphics.",[Platforms [Flash]; Deprecated("The flash target will be removed for Haxe 5")])
	| SwfHeader -> "swf_header",("define SWF header (width:height:fps:color)",[Platforms [Flash]; Deprecated("The flash target will be removed for Haxe 5")])
	| SwfMetadata -> "swf_metadata",("Include contents of the given file as metadata in the SWF.",[Platforms [Flash]; HasParam "file"; Deprecated("The flash target will be removed for Haxe 5")])
	| SwfPreloaderFrame -> "swf_preloader_frame",("Insert empty first frame in SWF.",[Platforms [Flash]; Deprecated("The flash target will be removed for Haxe 5")])
	| SwfProtected -> "swf_protected",("Compile Haxe `private` as `protected` in the SWF instead of `public`.",[Platforms [Flash]; Deprecated("The flash target will be removed for Haxe 5")])
	| SwfScriptTimeout -> "swf_script_timeout",("Maximum ActionScript processing time before script stuck dialog box displays.",[Platforms [Flash]; HasParam "time in seconds"; Deprecated("The flash target will be removed for Haxe 5")])
	| SwfUseDoAbc -> "swf_use_doabc",("Use `DoAbc` SWF-tag instead of `DoAbcDefine`.",[Platforms [Flash]; Deprecated("The flash target will be removed for Haxe 5")])
	| Sys -> "sys",("Defined for all system platforms.",[])
	| Unsafe -> "unsafe",("Allow unsafe code when targeting C#.",[Platforms [Cs]])
	| UseNekoc -> "use_nekoc",("Use `nekoc` compiler instead of the internal one.",[Platforms [Neko]])
	| Utf16 -> "utf16",("Defined for all platforms that use UTF-16 string encoding with UCS-2 API.",[])
	| Vcproj -> "vcproj",("GenCPP internal.",[Platforms [Cpp]])
	| WarnVarShadowing -> "warn_var_shadowing",("Warn about shadowing variable declarations.",[])
	| NoTre -> "no_tre",("Disable tail recursion elimination.",[])
	| MessageReporting -> "message.reporting",("Select message reporting mode for compiler output. (default: classic)",[HasParam "mode: classic | pretty | indent"])
	| MessageNoColor -> "message.no_color",("Disable ANSI color codes in message reporting.",[])
	| MessageLogFile -> "message.log_file",("Path to a text file to write message reporting to, in addition to regular output.",[])
	| MessageLogFormat -> "message.log_format",("Select message reporting mode for message log file. (default: indent)",[HasParam "format: classic | pretty | indent"])
	| Last -> die "" __LOC__
	| Custom s -> s,("",[])

let deprecated_defines = [
	("advanced_telemetry","The flash target will be removed for Haxe 5");
	("fdb","The flash target will be removed for Haxe 5");
	("flash_strict","The flash target will be removed for Haxe 5");
	("flash_use_stage","The flash target will be removed for Haxe 5");
	("haxe3compat","This flag is no longer supported in Haxe 5");
	("haxe_boot","The flash target will be removed for Haxe 5");
	("jar_legacy_loader","The legacy JAR loader will be removed in Haxe 5");
	("network_sandbox","The flash target will be removed for Haxe 5");
	("no_flash_override","The flash target will be removed for Haxe 5");
	("no_swf_compress","The flash target will be removed for Haxe 5");
	("swc","The flash target will be removed for Haxe 5");
	("swf_compress_level","The flash target will be removed for Haxe 5");
	("swf_debug_password","The flash target will be removed for Haxe 5");
	("swf_direct_blit","The flash target will be removed for Haxe 5");
	("swf_gpu","The flash target will be removed for Haxe 5");
	("swf_header","The flash target will be removed for Haxe 5");
	("swf_metadata","The flash target will be removed for Haxe 5");
	("swf_preloader_frame","The flash target will be removed for Haxe 5");
	("swf_protected","The flash target will be removed for Haxe 5");
	("swf_script_timeout","The flash target will be removed for Haxe 5");
	("swf_use_doabc","The flash target will be removed for Haxe 5")
]
